# coding: utf-8

require './TrueLegacyGraphicsCommon'
require 'tk'
require 'tkextlib/tkimg/png'					# yum install tkimg / aptitude install libtk-img

#===============================================================================
#
#	Class: LegacyGraphics
#
class LegacyGraphics < TrueLegacyGraphicsCommon

	@@color = Array['black', 'blue', 'red', 'magenta', 'green', 'cyan', 'yellow', 'white']

	def initialize(h_dmy, w_dmy, y_dmy, x_dmy, gy = 400, gx = 640, cy = 16, cx = 8, c = 0, out = {})
		@lx = 0
		@ly = 0

		@root = TkRoot.new {
			title('TrueLegacyGraphicsTk')
		}

		@canvas = TkCanvas.new {
			width(gx)
			height(gy)
		}.pack

		fill(0, 0, gx - 1, gy - 1, c)
	end

	#---------------------------------------------------------------------------
	#
	#	_line
	#
	def _line(x1, y1, x2, y2, c, w, d, a)

		TkcLine.new(@canvas, x1 + 1, y1 + 1, x2 + 1, y2 + 1) {
			width(w)
			fill(@@color[c.class <= Numeric ? c : 7])
			d and dash(d)						# '-', '-.', '-..'
			a and arrow(a)						# 'first', 'last', 'both'
		}
		pset(x2, y2, c)
	end

	def fill(x1, y1, x2, y2, c)

		TkcRectangle.new(@canvas, x1 + 1, y1 + 1, x2 + 2, y2 + 2) {
			width(0)
			fill(@@color[c.class <= Numeric ? c : 7])
		}
	end

	def polygon(points, c, f = '', w = 1)		# points = [[x1, y1], [x2, y2], [x3, y3]...]

		TkcPolygon.new(@canvas, *points.flatten) {
			width(1)
			outline(@@color[c.class <= Numeric ? c : 7])
			fill(nil)
		} unless(f =~ /f/i)
		TkcPolygon.new(@canvas, *points.flatten) {
			width(0)
			fill(@@color[c.class <= Numeric ? c : 7])
		} if(f =~ /f/i)
	end

	def put_image_png(x, y, file)

		TkcImage.new(@canvas, x, y) {
			image(TkPhotoImage.new('file' => file))
			anchor('nw')
		}
	end

	def _text(x, y, s, c, ps = {})

		f = '%s %s'% [ps[:font_family] || 'Helvetica', fs = ps[:font_size] || 10]
		ps[:get_size] and return([s.length + fs, fs])
		a = 'nw'
		a = 'n'		if(it = ps[:layout_alignment] and it =~ /center/i)
		a = 'ne'	if(it = ps[:layout_alignment] and it =~ /right/i)
		TkcText.new(@canvas, x, y) {
			text(s)
			fill(@@color[c.class <= Numeric ? c : 7])
			font(TkFont.new(f))					# Times / Courier / Helvetica
			anchor(a)							# center / w / e / n / s
		}
	end

	def refresh(fps = nil)
		Tk.mainloop
	end
end

