#!/usr/bin/env ruby

require 'curses'
#require './LegacyGraphics'
#require './TrueLegacyGraphics'
#require './TrueLegacyGraphicsGtk2'
require './TrueLegacyGraphicsCairo'

Curses.init_screen if($curses_enable)			# screen 3 (^_^;)
winX = Curses.cols  - 0
winY = Curses.lines - 0
# for ScanNCut CM110 - 72dpi - 296mm x 298mm(603mm)
win  = LegacyGraphics.new(winY, winX, 0, 0,  838,  844, 16, 8, false, { :file => 'cut', :type => 'svg' })   # png/pdf/svg/ps
# for Speedy 100 - 72dpi - 610mm x 305mm
#win = LegacyGraphics.new(winY, winX, 0, 0, 1729,  864, 16, 8, false, { :file => 'cut', :type => 'svg' })   # png/pdf/svg/ps
win.clear; win.box('|', '-')					# cls

class Integer
	def mm
		(self * 72.0 / 25.4).to_i
	end
end
win.line(0, 0, 200.mm, 200.mm, 0, 'b')

win.rotate(45, 200, 200) {
	win.line(  280, 200, 300, 200, 0)
	win.circle(200, 200, 100, 0, '', 1, { :START => 0, :END => Math::PI * 1.5})
	win.circle(200, 200,  80, 0, '', 1, { :START => 0, :END => Math::PI * 1.5})
	win.line(  200, 120, 200, 100, 0)
}

ps = { :font_family => 'pacman.bmf', :font_weight => 400, :font_size => 40, :layout_width => 200, :layout_alignment => 'center', :get_size => true }
p xy = win.text(100, 200, 'PAC', 0, ps)
ps[:get_size] = false
win.text(100, 200, 'PAC', 0, ps)
sx = (200 - xy[0]) / 2
win.line(100 + sx, 200, 100 + sx + xy[0], 200 + xy[1], 0, 'b')

pat = [
	[5,5,5,5,5,5,5,5],
	[5,9,9,9,9,9,9,1],
	[5,9,9,9,9,9,9,1],
	[5,9,9,9,9,9,9,1],
	[5,9,9,9,9,9,9,1],
	[5,9,9,9,9,9,9,1],
	[5,9,9,9,9,9,9,1],
	[5,1,1,1,1,1,1,1],
]
pat = win.get(2, 2, 16, 16, 'images/sample.png', 5, 5) {|c|
	c.opacity > 0 ? 9 : 4
}
pat.each {|p| p p }

opt = { :dot_size => 4, :layout_width => 200, :layout_alignment => 'center', :get_size => true }
p xy = win.put(100, 200, pat, opt)
opt[:get_size] = false
win.put(100, 199 - xy[1], pat, opt)

win.refresh
win.getch
win.close

