#!/usr/bin/env ruby

require 'curses'
#require './LegacyGraphics'
#require './TrueLegacyGraphics'
#require './TrueLegacyGraphicsGtk2'
require './TrueLegacyGraphicsCairo'
#require './TrueLegacyGraphicsOpenGL'

Curses.init_screen if($curses_enable)			# screen 3 (^_^;)
winX = Curses.cols  - 0
winY = Curses.lines - 0
# for A4 - 144dpi - 210mm x 297mm - (上下左右の余白 4.23mm)
#win = LegacyGraphics.new(winY, winX, 0, 0, 1635, 1142, 16, 8, 7,		{ :file => 'cutwallet', :type => 'pdf' })	# png/pdf/svg/ps
# for ScanNCut CM110 - 72dpi - 296mm x 298mm(603mm)
#win = LegacyGraphics.new(winY, winX, 0, 0,  838,  844, 16, 8, false,	{ :file => 'cutwallet', :type => 'svg' })	# png/pdf/svg/ps
#win = LegacyGraphics.new(winY, winX, 0, 0,  838,  844, 16, 8, 7,		{ :file => 'cutwallet', :type => 'svg' })	# png/pdf/svg/ps
# for Speedy 100 -  72dpi - 610mm x 305mm
#win = LegacyGraphics.new(winY, winX, 0, 0, 1729,  864, 16, 8, false,	{ :file => 'cutwallet', :type => 'svg' })	# png/pdf/svg/ps
win  = LegacyGraphics.new(winY, winX, 0, 0, 1729,  864, 16, 8, 7,		{ :file => 'cutwallet', :type => 'svg' })	# png/pdf/svg/ps
win.clear; win.box('|', '-')					# cls

# 描画距離に合うよう、破線パターンを補正
#	pat = [開始ポインタ, [描画距離, 間隔距離, 描画距離, 間隔距離, ...]]
def win.fit_dline(dist, pat, opt = {})
	sum = 0.0; npat1 = pat[1].size; n = -1; loop { n += 1
		sum += pat[1][(pat[0] + n) % npat1]
		if(opt[:FIT])
			n % npat1 == 0 or next
		else
			n % npat1 == npat1 - 1 or next
		end
		sum > dist + (opt[:PDIST] || 0) and break
	}
	cpat = []; pat[1].each {|l| cpat << l * dist / sum }
	p [dist, [pat[0], cpat], opt]
	[dist, [pat[0], cpat], opt]
end

def win._tDForward(dist, pat, step, opt = {})
	rest = dist; while(rest > step)
		step > 0 and (it = opt[:AFORWARD]) ? it.call(step, pat, opt) : self.tForward(step)
		rest -= step
		step = pat[1][(pat[0] += 1) % pat[1].size]
		pat[0] % 2 == 0 ? self.tPenDown : self.tPenUp
	end
	(it = opt[:AFORWARD]) ? it.call(rest, pat, opt) : self.tForward(rest)
	step - rest
end

# 指定の破線パターンで直線を描画
def win.tDForward(dist, pat, opt = {})
	step = pat[1][pat[0]]
	pat[0] % 2 == 0 ? self.tPenDown : self.tPenUp
	self._tDForward(dist, pat, step, opt)
end

# 指定の破線パターンでベジェ曲線を描画
def win.tDThrough(ang, dist, th_ang = 0, opt = {})

	# 曲線の描画距離を得て、破線パターンを補正
	tdist = 0; self.tPenUp
	self.tPush
	self.tThrough(ang, dist, th_ang, opt) {|ang, dist|
		tdist += dist
		self.tRight(ang)
		self.tForward(dist)
	}
	pat = self.fit_dline(tdist, opt[:PAT], opt)[1]
	self.tPop

	# 直線の繰り返しでベジェ曲線を描画
	step = pat[1][pat[0]]
	pat[0] % 2 == 0 ? self.tPenDown : self.tPenUp
	self.tThrough(ang, dist, th_ang, opt) {|ang, dist|
		self.tRight(ang)
		step = self._tDForward(dist, pat, step, opt)
	}
end

class Numeric
	def to_in
		self * 72 / 25.4
	end
end

class Array
	def ave
		total = 0; self.size.times {|n|
			total += self[n]
		}
		total / self.size
	end
end

# XY座標群の中心にイメージを描画
def win.put_image_png_center(xs, ys, file, opt = {})
	xy = LegacyGraphics.get_image_size_png(file)
	tx = opt[:TX] || 1.0; ty = opt[:TY] || 1.0
	self.put_image_png(xs.ave - xy[0] * tx / 2, ys.ave - xy[1] * ty / 2, file, opt)
end

def win.put_image_png2(x, y, file, opt = {})
	xy = LegacyGraphics.get_image_size_png(file)
	tx = opt[:TX] || 1.0; ty = opt[:TY] || 1.0
	self.put_image_png(x, y, file, opt)
end

aforward = lambda {|step, pat, opt|				# 菱目打ち

	win.tPushStat()

	@lastpat0 ||= false
	if(win.tPen[0] == :DOWN and @lastpat0 != pat[0])
		win.tPush()
		angle = opt[:HISHIME_ANGLE]
		dl = pat[1][pat[0] % pat[1].size] / cos(angle * PI / 180.0)
		sl = dl * sin(angle * PI / 180.0) / 2
		win.tLeft(90)
		win.tPenUp; win.tForward(sl)
		win.tRight(90 + angle)
		win.tPenDown; win.tForward(dl); win.tPenUp
		win.tLeft(angle + 90)
		win.tForward(sl)
		win.tRight(90)
		win.tPop()
	end
	@lastpat0 = pat[0]

	win.tPenUp
	win.tForward(step)
	win.tPopStat()
}

unless(ARGV[0])
	raise(<<USAGE)
Usage: #{$0} <type>
USAGE
end

win.tHome
win.depth3d(0, 30)

if(ARGV[0] =~ /w/)

	# ベジェ曲線テスト
	win.tSetPenColor(2)
	win.tSetPos(64, 64)
	win.tSetHeading(90)
	win.tArc(360, 4)

	win.tForward(100)
	win.tArc(360, 4)

	2.times {
		win.tThrough( 45, sqrt(120 ** 2 + 120 ** 2), -45, { :DIVS => 16 }) {|ang, dist|
			win.tRight(ang); win.tForward(dist)
		}
		win.tArc(360, 4)
		win.tThrough(-45, sqrt(120 ** 2 + 120 ** 2),  45, { :DIVS => 16 }) {|ang, dist|
			win.tRight(ang); win.tForward(dist)
		}
		win.tArc(360, 4)
	}

	# 波線テスト
  [false, true].each {|fit|
	win.tSetPenColor(fit ? 4 : 1)
	win.tSetPos(64, fit ? 192 : 128)
	win.tSetHeading(90)
	win.tArc(360, 4)

	win.tDForward(*win.fit_dline(100, [0, [20, 10]], { :FIT => fit }))
	win.tArc(360, 4)

	2.times {
		win.tDThrough( 45, sqrt(120 ** 2 + 120 ** 2), -45, { :PAT => [0, [20, 10]], :DIVS => 16, :FIT => fit })
		win.tArc(360, 4)
		win.tDThrough(-45, sqrt(120 ** 2 + 120 ** 2),  45, { :PAT => [0, [20, 10]], :DIVS => 16, :FIT => fit })
		win.tArc(360, 4)
	}
  }

elsif(ARGV[0] =~ /s/)

	# 貝型カードケース

	cx = 200; cy = 350
	w1 =  65; h1 = 218	# 65mm x 218m
	w2 = w1 * 72 / 25.4 / 2; h2 = h1 * 72 / 25.4 / 2

	win.tSetPos(cx - w2, cy)

	win.tLeft(5)
	vt =  win.tTowards(cx, cy - h2)
	win.tDThrough(*vt, 95 - vt[0], { :SMOOTH => [0.8, 0.8], :PAT => [0, [1, 10, 1, 0]], :DIVS => 16 })
	vt =  win.tTowards(cx + w2, cy)
	win.tDThrough(*vt, 95 - vt[0], { :SMOOTH => [0.8, 0.8], :PAT => [0, [1, 10, 1, 0]], :DIVS => 16 })
	win.tLeft(5)

	win.tLeft(5)
	vt =  win.tTowards(cx, cy + h2)
	win.tDThrough(*vt, 95 - vt[0], { :SMOOTH => [0.8, 0.8], :PAT => [0, [1, 10, 1, 0]], :DIVS => 16 })
	vt =  win.tTowards(cx - w2, cy)
	win.tDThrough(*vt, 95 - vt[0], { :SMOOTH => [0.8, 0.8], :PAT => [0, [1, 10, 1, 0]], :DIVS => 16 })
	win.tLeft(1)

	win.tSetPos(cx - w2 - 10, cy)

	win.tLeft(10)
	vt =  win.tTowards(cx, cy - h2 - 10)
	win.tThrough(*vt, 95 - vt[0], { :SMOOTH => [0.8, 0.8] })
	vt =  win.tTowards(cx + w2 + 10, cy)
	win.tThrough(*vt, 95 - vt[0], { :SMOOTH => [0.8, 0.8] })
	win.tLeft(5)

	win.tLeft(5)
	vt =  win.tTowards(cx, cy + h2 + 10)
	win.tThrough(*vt, 95 - vt[0], { :SMOOTH => [0.8, 0.8] })
	vt =  win.tTowards(cx - w2 - 10, cy)
	win.tThrough(*vt, 95 - vt[0], { :SMOOTH => [0.8, 0.8] })
	win.tLeft(5)

elsif(ARGV[0] =~ /k/)

	# ROADSTER キーホルダー

	w1 = 46.to_in;	h1 = 20.to_in				# 縫い目内の幅と高さ
	w2 = 20.to_in								# 折り返し部の長さ

	r1 =  3.to_in;	r1s = r1 * sqrt(2)			# 縫い目の外側のR
	r2 =  5.to_in;	r2s = r2 * sqrt(2)			# 折り返し部へのR

	s1 = 1.0.to_in;	s1r	= 4.0.to_in - s1		# 縫い目の間隔

	images = ['roadster.png', 'skyactiv.png']
	images = ['axela.png', 'skyactiv.png']

	win.tSetPos(60.to_in, 10.to_in)
	win.tSetHeading(0)
	win.tSetPenColor(2)
	win.tLeft(90)								# 中央上部から←

	[-1, 1].each {|n|

		# cut
		rh = sqrt((h1 / 2 + r1) ** 2 + (15 + r1) ** 2)
		x = atan((h1 / 2 + r1) / (15 + r1)) * 180 / PI
		win.tForward(w1)						# ←
		win.tThrough(-x, rh, x - 90)			# ↓
		win.tThrough(x - 90, rh, -x)			# ↓
		win.tForward(w1)						# →

		win.tPenUp
		win.tLeft(90)
		win.tForward(r1)
		win.tPenDown

		xs = []; ys = []
		rh = sqrt((h1 / 2) ** 2 + (15) ** 2)
		x = atan((h1 / 2) / (15)) * 180 / PI
		win.tLeft(90);  xs << win.tXpos; ys << win.tYpos
		win.tDForward(*win.fit_dline(w1, [0, [s1, s1r]], { :AFORWARD => aforward, :HISHIME_ANGLE => 20 * n }))
		xs << win.tXpos; ys << win.tYpos
		win.tDThrough(x, rh, 90 - x, { :PAT => [n == -1 ? 0 : 0, [s1, s1r]], :DIVS => 32, :FIT => (n == -1 ? false : true), :AFORWARD => aforward, :HISHIME_ANGLE => 20 * n })
		win.tDThrough(90 - x, rh, x, { :PAT => [n == -1 ? 0 : 1, [s1, s1r]], :DIVS => 32, :FIT => (n == -1 ? true : false), :AFORWARD => aforward, :HISHIME_ANGLE => 20 * n }) #, :PDIST => 10 })
		xs << win.tXpos; ys << win.tYpos
		win.tDForward(*win.fit_dline(w1, [1, [s1, s1r]], { :AFORWARD => aforward, :HISHIME_ANGLE => 20 * n }))
		win.tRight(90); xs << win.tXpos; ys << win.tYpos

		win.tPenUp
		win.tForward(h1 + r1)
		win.tLeft(90)
		win.tPenDown

		# cut
		win.tThrough(-45, r1s + r2s,  45)
#		win.tThrough(-45, r1s + r2s,  45, { :SMOOTH => [0.85228, 0.85228] })
		win.tForward(w2)
		win.tThrough( 45, r1s + r2s, -45)

		win.put_image_png_center(xs, ys, images.shift, { :TX => 0.2, :TY => 0.2 })	# 72dpi / 360dpi

#		win.tArc(360, 4)						# for debug
	}

elsif(ARGV[0] =~ /p/)

	# passcase
	w1 = 46.to_in;	h1 = 20.to_in				# 縫い目内の幅と高さ
	w2 = 20.to_in								# 折り返し部の長さ
	s1 = 1.0.to_in;	s1r	= 4.0.to_in - s1		# 縫い目の間隔

	win.tSetPos(300, 100)
	win.tSetHeading(0)
	win.tRight(90)
	win.tDForward(*win.fit_dline(100, [0, [s1, s1r]], { :AFORWARD => aforward, :HISHIME_ANGLE => 20 }))
#	win.tDForward(*win.fit_dline(300, [0, [4, 6]], { :FIT   => true }))
#	win.tDThrough(45, sqrt(200 ** 2 + 200 ** 2), 45, { :PAT => [0, [4, 16]], :DIVS => 20, :FIT => true, :AFORWARD => aforward, :HISHIME_ANGLE => 40 })


elsif(ARGV[0] =~ /S/)

	# 定規
=begin
	win.tSetPos(300, 100)
	win.tSetHeading(0)

	10.times {
		win.tForward(10.to_i)
		win.tBack(10.to_i)

		win.tRight(90)
		win.tForward(10.to_i)
		win.tLeft(90)
	}

	win.tSetPos(300, 110)
	win.tSetHeading(0)
	win.tRight(90)
	win.tForward(300)

	win.tSetPos(300, 110)
	win.tSetHeading(0)
	win.tRight(90)
	win.tSetPenColor(4)
	win.tDForward(*win.fit_dline(300, [0, [4, 6]], { :FIT   => true }))

	win.tSetPos(300, 110)
	win.tSetHeading(0)
	win.tRight(90)
	win.tSetPenColor(2)
	win.tDForward(*win.fit_dline(300, [0, [4, 6]], { :FIT   => true }), { :FORWARDy => forward_y, :HISHIME_ANGLE => 20 })
	win.tSetPenColor(0)

	win.tSetPos(300, 115)
	win.tSetHeading(0)
	win.tRight(90)
	win.tForward(300)

	win.tSetPos(300, 120)
	win.tSetHeading(0)
	win.tRight(90)
	win.tDForward(*win.fit_dline(300, [0, [4, 16]], { :FIT   => true }), { :FORWARDy => forward_y, :HISHIME_ANGLE => 30 })

	win.tSetPos(300, 125)
	win.tSetHeading(0)
	win.tRight(90)
	win.tThrough(45, sqrt(100 ** 2 + 100 ** 2), 45)
=end

	win.tSetPos(300, 100)
	win.tSetHeading(0)
	win.tSetPenColor(0)
	win.tSetPenWidth(5)
	win.tRight(90)
	win.tForward(300)
	win.tSetPos(300, 110)
	win.tDForward(*win.fit_dline(300, [0, [16, 4, 4, 4]]))
	win.tSetPos(300, 120)
	win.tDForward(*win.fit_dline(300, [0, [16, 4, 4, 4]], { :FIT => true }))
	win.tSetPos(300, 130)
	win.tDForward(*win.fit_dline(300, [3, [16, 4, 4, 4]], { :FIT => true }))
	win.tSetPos(300, 140)
	win.tDForward(*win.fit_dline(300, [3, [16, 4, 4, 4]]))

	win.tSetPos(300, 200)
	win.tSetHeading(0)
	win.tSetPenColor(0)
	win.tSetPenWidth(5)
	win.tRight(90)
	win.tPush()
	win.tThrough(45, sqrt(200 ** 2 + 200 ** 2), 45)

	win.tSetPos(350, 200)
	win.tSetHeading(90)
	win.tDThrough(45, sqrt(200 ** 2 + 200 ** 2), 45, { :DIVS => 20, :PAT => [0, [4, 16]] })
	win.tSetPos(400, 200)
	win.tSetHeading(90)
	win.tDThrough(45, sqrt(200 ** 2 + 200 ** 2), 45, { :DIVS => 20, :PAT => [0, [4, 16]], :FIT => true })
	win.tSetPos(450, 200)
	win.tSetHeading(90)
	win.tDThrough(45, sqrt(200 ** 2 + 200 ** 2), 45, { :DIVS => 20, :PAT => [1, [4, 16]], :FLOAT => true })
	win.tSetPos(380, 200)
#	win.tDForward(*win.fit_dline(300, [1, [4, 16]]))

#	win.tPop()
#	win.tPush()
#	win.tSetPenColor(2)
#	win.tSetPenWidth(3)
#	win.tThrough( 45, sqrt(200 ** 2 + 200 ** 2), 45)
#	win.tThrough( 45, sqrt(200 ** 2 + 200 ** 2), 45, { :DIVS => 3 }) {|ang, dist|
#		win.tRight(ang); win.tForward(dist)
#	}
#	win.tDThrough(45, sqrt(200 ** 2 + 200 ** 2), 45, { :PAT => [0, [4, 16]], :DIVS => 20, :FIT => true })

	win.tPop()
	win.tSetPenColor(4)
	win.tSetPenWidth(1)
	win.tDThrough(45, sqrt(200 ** 2 + 200 ** 2), 45, { :PAT => [0, [4, 16]], :DIVS => 20, :FIT => true, :AFORWARD => aforward, :HISHIME_ANGLE => 40 })

elsif(ARGV[0] =~ /W/)

	# real

#	w1 =  65.to_in; w2 =  45.to_in; w3 =  20.to_in				# w1: 片幅, w2: 折幅, w3: 余幅
	w1 = 256 * 3.5 / 5; w2 =  192 * 3.5 / 5; w3 =  20.to_in		# w1: 片幅, w2: 折幅, w3: 余幅
	h1 = 105.to_in; h2 =  95.to_in; h3 =  80.to_in				# h1: 高さ, h2: 革2高さ, h3: 革3高さ

	r1 = 2.5.to_in;	r1s = r1 * sqrt(2)							# r1: 角半径
	r2 =  10.to_in;	r2s = r2 * sqrt(2)							# r2: 革1凹半径

	s1 = 4.to_in												# 

	def win.tDForward2(dist, pat, pen)
		pen ? self.tDForward(dist, pat) : (self.tPenUp; self.tForward(dist); self.tPenDown)
	end

#	win.tSetPos(300, 100)
#	win.tSetHeading(0)
#	win.tArc(360, 4)
#	win.tPenUp; win.tForward(r1); win.tPenDown
#	win.tLeft(90)
#	win.tPenUp; win.tForward(w2 / 2 + r1); win.tPenDown

#	2.times {													# gaikei

#		win.tForward(w1)
#		win.tThrough(-45, r1s, -45)
#		win.tForward(h1)
#		win.tThrough(-45, r1s, -45)
#		win.tForward(w1)

#		if(ARGV[0] =~ /[23]/)									# sep
#			win.tLeft(90)
#			win.tForward(h1 + r1 * 2)
#			win.tLeft(180)
#			win.tPenUp
#			win.tForward(h1 + r1 * 2)
#			win.tPenDown
#			win.tLeft(90)
#		end

#		if(ARGV[0] =~ /0/)										# aida
#			win.tSetPenColor(5)
#			win.tForward(w2 + r1 * 2)
#			win.tSetPenColor(0)
#		end
#	}

	[0].each {|sf0| sf = sf0.to_s
#	[0, 1, 2, 4].each {|sf0| sf = sf0.to_s
#	[0, 1, 2, 3, 4].each {|sf0| sf = sf0.to_s

		win.tSetPos(300, 350)
		win.tSetHeading(0)

		if(sf =~ /0/)
																				win.tArc(360, 4)
			win.tSetPenColor(4)

			win.tLeft(90)
			win.tPenUp; win.tForward(w1 + r1 + (w2 + w3) / 2); win.tPenDown	# 左下スタート
			2.times {
				win.tThrough(  45, r1s,   45)
				win.tForward(h1)								# ↑ left,	↓ right
				win.tThrough(  45, r1s,   45)
				win.tForward((w1 + r1) * 2 + w2 + w3)			# → top,	← bottom
			}

		elsif(sf =~ /1/)

			win.tSetPenColor(1)
																				win.tArc(360, 6)
			win.tLeft(90)
			win.tPenUp; win.tForward(w1 + r1 + w2 / 2); win.tPenDown

			win.tThrough(  45, r1s,   45)
			win.tForward(h1)									# ↑ left
			win.tThrough(  45, r1s,   45)

			win.tThrough(  45, r2s,  -45)
			win.tForward((w1 + r1) * 2 + w2 - r2 * 2)			# → top
			win.tThrough( -45, r2s,   45)

			win.tThrough(  45, r1s,   45)
			win.tForward(h1)									# ↓ right
			win.tThrough(  45, r1s,   45)
			win.tForward((w1 + r1) * 2 + w2)					# ← bottom

		elsif(sf =~ /2/)

			win.tSetPenColor(1)
																				win.tArc(360, 6)
			[1, -1].each {|pn|

				win.tLeft(90 * pn)
				win.tPenUp; win.tForward(w2 / 2); win.tPenDown

				win.tForward(w1 + r1)							# ← bottom
				win.tThrough(  45 * pn, r1s,   45 * pn)
				win.tForward(h2)								# ↑ left
				win.tThrough(  45 * pn, r1s,   45 * pn)
				win.tForward(w1 + r1)							# → top
				win.tRight(90 * pn)
				win.tForward(h2 + r1 * 2)						# ↓ right

				win.tLeft(90 * pn)
				win.tPenUp; win.tForward(w2 / 2); win.tPenDown
				win.tLeft(90 * pn)
			}

		elsif(sf =~ /3/)

			win.tSetPenColor(2)
																				win.tArc(360, 6)
			[1, -1].each {|pn|

				win.tLeft(90 * pn)
				win.tPenUp; win.tForward(w2 / 2); win.tPenDown

				win.tForward(w1 + r1)							# ← bottom
				win.tThrough(  45 * pn, r1s,   45 * pn)
				win.tForward(h3)								# ↑ left
#				win.tThrough(  45 * pn, r1s,   45 * pn)
rrr = 30.0
				win.tThrough(  45 * pn, r1s,   (45 + rrr) * pn)
p xc = cos(rrr * PI / 180.0)
p xs = sin(rrr * PI / 180.0)
#				win.tForward(w1 + r1)							# → top
				win.tForward(w1 / xc + r1)						# → top
#				win.tRight(90 * pn)
				win.tRight((90 - rrr) * pn)
#				win.tForward(h3 + r1 * 2)						# ↓ right
				win.tForward(h3 - w1 * xs + r1 * 2)						# ↓ right

				win.tLeft(90 * pn)
				win.tPenUp; win.tForward(w2 / 2); win.tPenDown
				win.tLeft(90 * pn)
			}

		elsif(sf =~ /4/)

			win.tSetPenColor(2)
																				win.tArc(360, 6)
			[-1].each {|pn|

				win.tLeft(90 * pn)
				win.tPenUp; win.tForward(w2 / 2); win.tPenDown

				win.tForward(w1 + r1)							# ← bottom
				win.tThrough(  45 * pn, r1s,   45 * pn)
				win.tForward(h2)								# ↑ left
				win.tRight(90 * pn)
				xy1 = win.tPos

				win.tForward(w1 + r1 * 2)						# → top
				win.tRight(90 * pn)
				win.tForward(h2 + r1)							# ↓ right
				xy2 = win.tPos

				tx = (xy1[0] - xy2[0]) / 256.0
				# ./cutDotPat.rb image.png -l -j -o > cutscript
				open('cutscript') {|fh|
					eval(fh.read)
				}
				win.put_image_png2(xy2[0], xy2[1], 'darius/naname.png', { :TX => tx, :TY => tx })	# 72dpi / 360dpi / illust < 512
			}
		end




		[].each {|pn|
#		[1, -1].each {|pn|

			win.tSetPos(300, 350)
			win.tSetHeading(0)

			win.tLeft(90 * pn)
			win.tPenUp; win.tForward(w2 / 2); win.tPenDown

																# gaikei
			win.tForward(w1 + r1)								# ← bottom
			win.tThrough(45 * pn, r1s, 45 * pn)
			win.tForward(h2 + r1)								# ↑ left
																				win.tArc(360, 4)
			# cut
			if(sf =~ /0/)
				win.tForward(h1 - h2 - r1)
				win.tThrough(45 * pn, r1s, 45 * pn)
				win.tForward(w1 + r1)							# → top
				win.tRight(90 * pn)
				win.tForward(h1 - h2 - r1)
				win.tForward(h2 + r1 * 3)						# ↓ right
			else
				win.tRight(90 * pn)
				win.tForward(w1 + r1 * 2)						# → top
				win.tRight(90 * pn)
				win.tForward(h2 + r1 * 2)						# ↓ right
			end

			win.tRight(90 * pn)
#=begin
			# nuime
			win.tPenUp											# to uchi
			win.tForward(r1)
			win.tRight(90 * pn)
			win.tForward(r1)
			win.tLeft(90 * pn)
			win.tPenDown

			win.tDForward2(*win.fit_dline(w1, [0, [1, s1 -1]], { :FIT   => true }), true)		# ← bottom
			win.tRight(90 * pn)
			win.tDForward2(*win.fit_dline(h2, [1, [1, s1 -1]], { :FLOAT => true }), true)		# ↑ left
			win.tRight(90 * pn)
			win.tDForward2(*win.fit_dline(w1, [0, [1, s1 -1]], { :FIT   => true }), sf =~ /12/)	# → top
			win.tRight(90 * pn)
			win.tDForward2(*win.fit_dline(h2, [1, [1, s1 -1]], { :FLOAT => true }), sf =~ /23/)	# ↓ right
			win.tRight(90 * pn)
#=end
		}
	}

else

	w_mm = 100.0; w = w_mm * 72 / 25.4
	h_mm = 180.0; h = h_mm * 72 / 25.4
	r_mm =  15.0; r = r_mm * 72 / 25.4

	(1..10).each {|l|
		win.tSetPos(64, l * 8 + 64)
		win.tSetHeading(90)
		win.tArc(360, 4)
		win.tDForward(*win.fit_dline(l * 30, [0, [20, 10]], { :FIT => true }))
		win.tArc(360, 4)
	}

	win.tSetPos(64, 64)
	win.tSetHeading(0)
	win.tRight(90)

	win.tDForward(*win.fit_dline(w, [0, [2, 10]]))
	win.tSetPenColor(2)
	win.tDThrough(45, sqrt(r ** 2 + r ** 2), 45, { :PAT => [0, [2, 10]], :DIVS => 8 })

#	win.tDForward(*win.fit_dline(h, [0, [2, 10]]))
#	win.tDThrough(45, sqrt(r ** 2 + r ** 2), 45, { :PAT => [0, [2, 10]], :DIVS => 8 })

#	win.tDForward(*win.fit_dline(w, [0, [2, 10]]))
#	win.tDThrough(45, sqrt(r ** 2 + r ** 2), 45, { :PAT => [0, [2, 10]], :DIVS => 8 })

#	win.tDForward(*win.fit_dline(h, [0, [2, 10]]))
#	win.tDThrough(45, sqrt(r ** 2 + r ** 2), 45, { :PAT => [0, [2, 10]], :DIVS => 8 })

end


win.refresh										# ページ生成(pdf/ps)

win.getch
win.close

__END__



win.tHome
win.tSetPos(400, 200)
win.tThrough(45, sqrt(100 ** 2 + 100 ** 2), 45)
win.tThrough(45, sqrt(100 ** 2 + 100 ** 2), 45)
win.tThrough(45, sqrt(100 ** 2 + 100 ** 2), 45)
win.tThrough(45, sqrt(100 ** 2 + 100 ** 2), 45)

win.tHome
win.tSetPos(400, 200)
vt =  win.tTowards(500, 100)
win.tThrough(*vt, 90 - vt[0])


#  6.5cm = 184( 92)
# 21.8cm = 618(309)
win.tHome

cx = 200; cy = 350
wd =  65; ht = 218
hw = wd / 25.4 * 72 / 2; hh = ht / 25.4 * 72 / 2

win.tSetPos(cx - hw, cy)

win.tLeft(20)
vt =  win.tTowards(cx, cy - hh)
win.tThrough(*vt, 110 - vt[0], { :SMOOTH => [0.8, 0.8] })
vt =  win.tTowards(cx + hw, cy)
win.tThrough(*vt, 110 - vt[0], { :SMOOTH => [0.8, 0.8] })

win.tLeft(40)

vt =  win.tTowards(cx, cy + hh)
win.tThrough(*vt, 110 - vt[0], { :SMOOTH => [0.8, 0.8] })
vt =  win.tTowards(cx - hw, cy)
win.tThrough(*vt, 110 - vt[0], { :SMOOTH => [0.8, 0.8] })
win.tLeft(20)

win.tRight(90)
win.tForward(10)
win.tLeft(90)

vt =  win.tTowards(cx, cy - hh + 10)
win.tThrough(*vt, 90 - vt[0], { :SMOOTH => [0.8, 0.8] })

vt =  win.tTowards(cx + hw - 10, cy)
win.tThrough(*vt, 90 - vt[0], { :SMOOTH => [0.8, 0.8], :DIVS => 18 }) {|ang, dist|
	win.tRight(ang)
	win.tForward(dist)
	win.tArc(360, 3)
}

#vt =  win.tTowards(cx, cy + hh - 10)
#win.tThrough(*vt, 90 - vt[0], { :SMOOTH => [0.8, 0.8] })

win.tHome
vt =  win.tTowards(win.tXpos + 200, win.tYpos - 100)
tlen = 0; win.tPenUp
win.tPush
win.tThrough(*vt, 90 - vt[0], { :SMOOTH => [0.8, 0.8], :DIVS => 18 }) {|ang, dist|
	tlen += dist
	win.tRight(ang)
	win.tForward(dist)
}
win.tPop

p tlen
p tlen / 14
p os = (tlen / 14 + 1).to_i
p os2 = tlen / os
p a =  2 * os2 / 14
p b = 10 * os2 / 14
p c =  2 * os2 / 14
#steps = [15, 10, 2, 10]; step = steps[stepp = 0]; win.tPenDown
#steps = [2, 10, 2, 0]; step = steps[stepp = 0]; win.tPenDown
steps = [a, b, c, 0]; step = steps[stepp = 0]; win.tPenDown
#p a + b + c
#p tlen / (a + b + c)

win.tThrough(*vt, 90 - vt[0], { :SMOOTH => [0.8, 0.8], :DIVS => 18 }) {|ang, dist|
	win.tRight(ang)
	rest = dist; while(step < rest)
		step != 0 and win.tForward(step)
		rest -= step
		step = steps[(stepp += 1) % steps.size]
		stepp % 2 == 0 ? win.tPenDown : win.tPenUp
	end
	win.tForward(rest)	# 最後 PenDown で抜けたい
	step -= rest
}

#win.tHome
#win.tThrough(45, 141.421356, 45, { :DIVS => 10 }) {|ang, dist|
#	win.tRight(ang)
#	win.tForward(dist)
#}

win.refresh										# ページ生成(pdf/ps)

win.getch
win.close

__END__

# 描画距離に合うよう、破線パターンを補正
#	pat = [開始ポインタ, [描画距離, 間隔距離, 描画距離, 間隔距離, ...]]
def win.fit_dline(dist, pat, opt = {})
	sum = 0.0; pat[1].each {|l| sum += l }
#	mag = (dist + (opt[:FIT] ? pat[1][-1] : 0)).to_f / (dist / sum + 1).to_i
	mag = (dist + (opt[:FIT] ? pat[1][-1] : 0) - (opt[:XXX] ? pat[1][-1] : 0)).to_f / (dist / sum + 1).to_i
	cpat = []; pat[1].each {|l| cpat << l * mag / sum }
	[dist, [pat[0], cpat]]

#	sum = 破線パターンの合計距離
#	(dist / sum + 1).to_i = 描画距離中にいくつ破線パターンを入れられるか
#	mag = 破線パターンに掛けるべき倍率
#	回数繰り返したら終わる？
end

def win._tDForward(dist, pat, step)
	rest = dist; while(step < rest)
		step != 0 and self.tForward(step)
		rest -= step
		step = pat[1][(pat[0] += 1) % pat[1].size]
		pat[0] % 2 == 0 ? self.tPenDown : self.tPenUp
	end
	self.tForward(rest)
	step - rest
end

# 指定の破線パターンで直線を描画
def win.tDForward(dist, pat)
	step = pat[1][pat[0]]
	pat[0] % 2 == 0 ? self.tPenDown : self.tPenUp
	self._tDForward(dist, pat, step)
end

# 指定の破線パターンでベジェ曲線を描画
def win.tDThrough(ang, dist, th_ang = 0, opt = {})

	# 曲線の描画距離を得て、破線パターンを補正
	tdist = 0; self.tPenUp
	self.tPush
	self.tThrough(ang, dist, th_ang, opt) {|ang, dist|
		tdist += dist
		self.tRight(ang)
		self.tForward(dist)
	}
	pat = self.fit_dline(tdist, opt[:PAT], opt)[1]
	self.tPop

	# 直線の繰り返しでベジェ曲線を描画
	step = pat[1][pat[0]]
	pat[0] % 2 == 0 ? self.tPenDown : self.tPenUp
	self.tThrough(ang, dist, th_ang, opt) {|ang, dist|
		self.tRight(ang)
		step = self._tDForward(dist, pat, step)
	}
end

