#!/usr/bin/env ruby

# RC PULSE CIRCUIT
#	$B?^2r!&$o$+$kEE;R2sO)(B $B?^(B2.14 p.93

require 'curses'
#require './LegacyGraphics'
#require './TrueLegacyGraphics'
#require './TrueLegacyGraphicsGtk2'
require './TrueLegacyGraphicsCairo'

Curses.init_screen if($curses_enable)			# screen 3 (^_^;)
winX = Curses.cols  - 0
winY = Curses.lines - 0
win  = LegacyGraphics.new(winY, winX, 0, 0)
win.clear; win.box('|', '-')					# cls

#$B!v!v!v!!%Q%i%a!<%?$*$h$S=i4|CM@_Dj(B

COL = 2
E = 10.0; R = 100; C = 0.0000001; DT = 0.000002	# E:Voltage R:Resister: C:Capacitor
CYCLE = 0.0002; DUTY = 0.4						# CYCLE: 0.0002 = 0.2ms
i = E / R; sigmi = 0; vc = 0; p = 0

#$B!v!v!v!!:BI8<4$*$h$SL\@9(B

TDIV = 50; DIV = TDIV * 1000 / 0.1				# 0.1ms$BL\@9(B / 50dot
VER = 300; HOR = 250
win.line(VER, HOR, 639, HOR, '-')
win.line(VER, HOR, VER,  50, '|')
(0..10).each {|m| win.line(VER, HOR - m * 10, VER - 5, HOR - m * 10, '+')}
(0..10).each {|m| win.line(VER + m * TDIV, HOR, VER + m * TDIV, HOR + 5, '+')}

#$B!v!v!v!!=i4|CM$N(BCRT$B=PNO(B

win.pset(VER, HOR - i * 500, COL)
win.pset(VER, HOR - vc * 5,  COL + 1)

#$B!v!v!v!!7W;;$H(BCRT$B=PNO(B

(1..(0.0006 / DT).to_i).each {|n|				# 0.0006 = 0.6ms
	p += 1
	(p * DT < CYCLE * DUTY) ? v = E : v = 0
	(p * DT > CYCLE)        ? p = 0 : nil
	i = (v - (DT / C) * sigmi) / (R + DT / C)	# $BEEN.(B
	sigmi += i									# $BEEN.$NN_@Q(B
	vc = sigmi * DT / C							# $B%3%s%G%s%5$NEE05(B
	win.pset(VER + n * DIV * DT, HOR - i * 500, COL)
	win.pset(VER + n * DIV * DT, HOR - vc * 5,  COL + 1)
}

win.refresh
win.getch
win.close

