#!/usr/bin/env ruby

include Math

class Gpgga

	attr_reader :time
	attr_reader :lat_d, :lng_d
	attr_reader :lat_r, :lng_r
	attr_reader :wcx, :wcy
	attr_reader :tx, :ty, :lx, :ly

	def initialize(l, zl = 15)
p l
		ls = l.split(/,/); @zl = zl
		ls[2].size == 0 and return(nil)
		@time = nil; if(ls[1] =~ /^(\d{2})(\d{2})(\d{2})\.(\d{2})/)
			ts = Time.now.to_a; ts[0] = $3.to_i; ts[1] = $2.to_i; ts[2] = $1.to_i
			@time = Time.utc(*ts).getlocal
		end
		@lat_d = dddmm2deg(ls[4]);	@lng_d = dddmm2deg(ls[2])
		@lat_r = deg2rad(@lat_d);	@lng_r = deg2rad(@lng_d)
		@wcx = rad2wcx(@lat_r);		@wcy = rad2wcy(@lng_r)
		@pcx = wc2pc(@wcx);			@pcy = wc2pc(@wcy)
		@tx, @ty, @lx, @ly = pc2tile(@pcx, @pcy)
	end

	def dddmm2deg(dddmm)
		dddmmf = dddmm.to_f
		deg = (dddmmf / 100).to_i
		deg + (dddmmf - deg * 100) / 60
	end

	def deg2rad(deg)
		deg * PI / 180.0
	end

	def rad2wcx(rad)
		r = 128 / PI
		r * (rad + PI)
	end

	def rad2wcy(rad)
		r = 128 / PI
		-r / 2 * log((1 + sin(rad)) / (1 - sin(rad))) + 128
	end

	def wc2pc(wc, zl = @zl)
		wc * 2 ** zl
	end

	def pc2tile(pcx, pcy)
		[	(pcx / 256).to_i,
			(pcy / 256).to_i,
			pcx % 256,
			pcy % 256,
		]
	end
end

__END__

