# coding: utf-8

class Holidays

	require 'nokogiri'

	def initialize
		@holidays = {}
	end

	def at(target_month)
		unless(@holidays[year = target_month.strftime('%Y')])
			uri = 'http://calendar.infocharge.net/cal/%04d/' % target_month.year	# 祝日情報を得る
			doc = Nokogiri::HTML(open(uri))

			@holidays[year] = {}; day = nil; en = []; doc.xpath('//td').each {|e|
				en << e; en.size % 3 == 2 and next
				day and @holidays[year][day.strftime('%Y%m%d')] = e.text and day = nil
				(es = e.text.split(/\D+/)).size == 3 and day = Time.local(*es)
			}
		end
		@holidays[year]
	end

	def [](d)
		at(d)[d.strftime('%Y%m%d')]
	end
end

class Date

	def holiday?
		@holidays ||= Holidays.new
		@holidays[self]
	end
end

