# coding: utf-8

class MapUri

	# Refer to http://portal.cyberjapan.jp/portalsite/version/v4/index.html

	def initialize
		@base_uri = 'http://cyberjapandata.gsi.go.jp/sqras/all/%s/latest/%s/%s.%s'
	end

	ls = [['地図', ['DJBMM', 'png']], ['空撮', ['DJBMO', 'jpg']], ['空撮1989年', ['NLII4', 'jpg']],
		['空撮1985年', ['NLII3', 'jpg']], ['空撮1981年', ['NLII2', 'jpg']], ['空撮1976年', ['NLII1', 'jpg']]]
	@@layers = []; @@layer_names = []; ls.each {|p|
		@@layer_names << p[0]
		@@layers << [[nil, nil]] * 5 + [['JAIS', 'png']] * 4 + [['BAFD1000K', 'png']] * 3 \
			+ [['BAFD200K', 'png']] * 3 + [p[1]] * 3 + [['FGD', 'png']]
	}

	def uri(x, y, z, l)	# x, y, zoom, layer
		dxy = []; sx = '%07d' % x; sy = '%07d' % y
		dxy << z.to_s
		(0..5).each {|p|
			dxy << sx[p, 1] + sy[p, 1]
		}
		@base_uri % [@@layers[l][z][0], dxy.join('/'), sx + sy, @@layers[l][z][1]]
	end

	def uris(x, y, z, l, xn = 2, yn = 2)
		uris = []; (0...yn).each {|yp|
			xuris = []; (0...xn).each {|xp|
				xuris << uri(x + xp, y + yp, z, l)
			}
			uris << xuris
		}
		uris
	end

	def luris(x, y, z, l, xn = 2, yn = 2)
		luris = []; (0...@@layers.size).each {|n|
			ll = (l + n) % @@layers.size
			luris << [@@layer_names[ll], uris(x, y, z, ll, xn, yn)]
		}
		luris
	end
end

class GMapUri < MapUri

	def initialize
		@base_uri = 'http://mt3.google.com/vt?lyrs=%s&z=%s&x=%s&y=%s'
	end

	def uri(x, y, z, l)	# x, y, zoom, layer(dummy)
		@base_uri % [l, z, x, y]
	end
end

class KMapUri < MapUri

	def initialize
		@base_uri = 'http://cyberjapandata.gsi.go.jp/xyz/std/%s/%s/%s.png'
	end

	def uri(x, y, z, l)	# x, y, zoom, layer(dummy)
		@base_uri % [z, x, y]
	end
end

__END__

