#!/usr/bin/env ruby

require './TrueLegacyGraphicsCairo'

# for A4 - 144dpi - 210mm x 297mm - (上下左右の余白 4.23mm)
win = LegacyGraphics.new(nil, nil, nil, nil, 1635, 1142, 16, 8, 7,		{ :file => 'mu_note', :type => 'pdf' })	# png/pdf/svg/ps

w = 30.0 * 144 / 25.4; h = 18.3 * 144 / 25.4
xs = (1142 -  6 * w) / 2; ys = (1635 - 15 * h) / 2

image_files = Dir.glob('images/mu/*.png')

n = -1; 2.times {
	7.times {|x|
		win.line(xs + x * w, ys, xs + x * w, ys + 15 * h, 0)
	}
	16.times {|y|
		win.line(xs, ys + y * h, xs + 6 * w, ys + y * h, 0)
	}

	15.times {|y|
		6.times {|x|

			p image_file = image_files[(n += 1) % image_files.size]
			iwh = LegacyGraphics.get_image_size_png(image_file)

			tw = (w / iwh[0]) * 0.8;	th = (h / iwh[1]) * 0.8
			thw = tw < th ? tw : th
			pw = iwh[0] * thw;			ph = iwh[1] * thw
			mw = (w - pw) / 2;			mh = (h - ph) / 2

			win.put_image_png(xs + x * w + mw, ys + y * h + mh, image_file, { :TX => thw, :TY => thw })
		}
	}

	win.refresh
}

win.close

__END__

