#!/usr/bin/env ruby
# coding: utf-8

# NEC PC-8001 のフォント画像を料理する「 PC-8001 フォントカッター」

require 'curses'
#require './LegacyGraphics'
#require './TrueLegacyGraphics'
#require './TrueLegacyGraphicsGtk2'
require './TrueLegacyGraphicsCairo'

Curses.init_screen if($curses_enable)			# screen 3 (^_^;)
winX = Curses.cols  - 0
winY = Curses.lines - 0
win  = LegacyGraphics.new(winY, winX, 0, 0, 400, 640, 16, 8, 0, { :file => 'dummy', :type => 'png' })	# png/pdf/ps
win.clear; win.box('|', '-')					# cls

# http://www.onionsoft.net/wp/archives/tag/pc-8001
# http://www.onionsoft.net/wp/wp-content/uploads/2010/02/80font.gif

begin
	p LegacyGraphics.get_image_size_png('80font.gif'); ox = 0; oy = 0

	fontdata = []; c = 0
	16.times {|cy|
		16.times {|cx|
			puts('code = 0x%02X(%d)' % [c, c]); c += 1
			8.times {|dy|
				bp = 0; 8.times {|dx|
					bp <<= 1
					dot = LegacyGraphics.point(ox + (cx * 8 + dx) * 2, oy + (cy * 8 + dy) * 2).red > 0x7FFF
					dot and bp += 1
					print(dot ? '#' : '/')
				}
				fontdata << bp
				puts
			}
		}
	}

	open('p8font.bmf', 'w') {|fh|
		fh.write(fontdata.pack('C*'))
	}
rescue
end

ht = 0x09.chr; cr = 0x0D.chr; cursor = 0x87.chr
boot = <<BOOT
NEC PC-8001 BASIC Ver 1.0
Copyright 1979 (C) by Microsoft

Ok
#{cursor}
BOOT

fkeys = [
	"#{ht}     ",
	'auto  ',
	'go to ',
	'list  ',
	"run#{cr}  ",
]

win.text(0, 0, boot, 4, { :font_family => 'p8font.bmf', :tx => 2, :ty => 2, :raster => 1 })
x = 2 << 4; fkeys.each {|fkey|
	win.text(x, 24 << 4, fkey, 4, { :font_family => 'p8font.bmf', :tx => 2, :ty => 2, :raster => 1, :reverse => 1, :vcode => true })
	x += 7 << 4
}

win.refresh
win.getch
win.close

__END__

