# coding: utf-8

class Date

	require 'nokogiri'

	@@qreki = {}

	@@rokuyo_h = {}; @@rokuyo_a = '先勝 友引 先負 仏滅 大安 赤口'.split(' ')
	@@rokuyo_a.each_index {|n|
		@@rokuyo_h[@@rokuyo_a[n]] = n
	}

	@@getsumei_h = {}; @@getsumei_a = 'DMY 睦月 如月 弥生 卯月 皐月 水無月 文月 葉月 長月 神無月 霜月 師走'.split(' ')
	@@getsumei_a.each_index {|n|
		@@getsumei_h[@@getsumei_a[n]] = n
	}

	def see_site_qreki
		unless(@@qreki[yyyymm = self.strftime('%Y%m')])
			uri = 'http://koyomi.vis.ne.jp/i/9rekical.php?PRMIN=%04d&PRMINMON=%02d' % [self.year, self.month]
			doc = Nokogiri::HTML(open(uri))
			days = [nil]; doc.xpath('//pre').each {|pre|
				pre.text.split(/\n/).each {|l|
					l =~ /^(\d+).([ *])(\d+)\/(\d+)(..)/ or next
					$2 == '*' and leap = true
					mon = $3.to_i
					day = $4.to_i
					rokuyo = $5
					getsurei = ''
					days << {
						:LEAP		=> leap,
						:MONTH		=> mon,
						:DAY		=> day,
						:ROKUYO		=> rokuyo,
						:GETSUREI	=> getsurei,
					}
				}
			}
			@@qreki[yyyymm] = days
		end
	end

	def qreki
		days = see_site_qreki unless(days = @@qreki[self.strftime('%Y%m')])
		days[self.day]
	end

	def qmday
		qreki[:DAY]
	end
	alias :qday :qmday

	def qmon
		qreki[:MONTH]
	end
	alias :qmonth :qmon

	def qwday
		qreki[:ROKUYO]
	end

	def qleap
		qreki[:LEAP]
	end

	alias :_orig_strftime :strftime
	def strftime(format)
		format.gsub!(/%qA/) {|f| @@rokuyo_a[qwday] }
		format.gsub!(/%qB/) {|f| @@getsumei_a[qmon] }
		format.gsub!(/%qd/) {|f| '%02d' % qmday }
		format.gsub!(/%ql/) {|f| qleap ? '閏' : '' }
		format.gsub!(/%qm/) {|f| '%02d' % qmon }
		format.gsub!(/%qY/) {|f| year + (mon < qmon ? 659 : 660) }
		_orig_strftime(format)
	end
end

__END__

