#!/usr/bin/env ruby

# http://www.imagemagick.org/script/command-line-processing.php
# convert -quality 100 target.png target.jpg

unless(ARGV.size == 2)
	abort(<<USAGE)
Usage: #{$0} <id> <jpgfile>
USAGE
end

imagedata = nil; open(ARGV[1]) {|fh|
	imagedata = [fh.read].pack('m').gsub(/\n/, '')
}

# <image id="imageX" width="NNN" height="NNN" xlink:href="data:image/png;base64,XXXX....XXXX"/>
# <image id="imageX" width="NNN" height="NNN" xlink:href="data:image/jpeg;base64,XXXX....XXXX"/>
$stdin.each {|l|
	if(l =~ /<image.*id="#{ARGV[0]}"/)
		print(l.gsub(/(xlink:href="data:image\/)png(;base64,)[^"]+"/, '\\1jpeg\\2%s"' % imagedata))
	else
		print(l)
	end
}

__END__

