#!/usr/bin/env ruby

require 'bundler/setup'

require 'curses'
#require './LegacyGraphics'
#require './TrueLegacyGraphics'
#require './TrueLegacyGraphicsGtk2'
require './TrueLegacyGraphicsCairo'

Curses.init_screen if($curses_enable)			# screen 3 (^_^;)
winX = Curses.cols  - 0
winY = Curses.lines - 0
# for A4 - 144dpi - 210mm x 297mm - (上下左右の余白 4.23mm)
#win = LegacyGraphics.new(winY, winX, 0, 0, 1635, 1142, 16, 8, 7,		{ :file => 'turtleTest', :type => 'pdf' })	# png/pdf/svg/ps
# for ScanNCut CM110 - 72dpi - 296mm x 298mm(603mm)
win  = LegacyGraphics.new(winY, winX, 0, 0,  838,  844, 16, 8, false,	{ :file => 'turtleTest', :type => 'svg' })	# png/pdf/svg/ps
# for Speedy 100 - 72dpi - 610mm x 305mm
#win = LegacyGraphics.new(winY, winX, 0, 0, 1729,  864, 16, 8, false,	{ :file => 'turtleTest', :type => 'svg' })	# png/pdf/svg/ps
win.clear; win.box('|', '-')					# cls

def c_curve(win, n, l)
	unless(n == 0)
		win.tLeft(45)
		c_curve(win, n - 1, l)
		win.tRight(90)
		c_curve(win, n - 1, l)
		win.tLeft(45)
	else
		win.tForward(l)
	end
end

def r_dragon(win, n, l)
	unless(n == 0)
		win.tLeft(45)
		r_dragon(win, n - 1, l)
		win.tRight(90)
		l_dragon(win, n - 1, l)
		win.tLeft(45)
	else
		win.tForward(l)
	end
end

def l_dragon(win, n, l)
	unless(n == 0)
		win.tRight(45)
		r_dragon(win, n - 1, l)
		win.tLeft(90)
		l_dragon(win, n - 1, l)
		win.tRight(45)
	else
		win.tForward(l)
	end
end

def tree(win, n, l)
	unless(n == 0)
		win.tSetPenWidth(n * 2)
		win.tForward(l)
		win.tRight(25)
		tree(win, n - 1, l / 1.5)
		win.tLeft(55)
		tree(win, n - 1, l / 1.3)
		win.tRight(30)
		win.tBack(l)
	else
		win.tForward(l)
		win.tBack(l)
	end
end

unless(ARGV[0])
	raise(<<USAGE)
Usage: #{$0} [ccurve|dragon|tree]
USAGE
end

win.tHome
if(ARGV[0] =~ /c/)
	win.tRight(90)
	c_curve(win, 12, 4)
elsif(ARGV[0] =~ /d/)
	win.tRight(90)
	r_dragon(win, 12, 4)
else
	tree(win, 7, 96)
end

win.refresh										# ページ生成(pdf/ps)

win.getch
win.close

__END__

